import java.io.FileInputStream;
import java.io.FileOutputStream;


public class TextEncToSjis {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		String infilepath = args[0];
		String outfilepath = infilepath + ".fix";
		
		try{
			FileInputStream fis = new FileInputStream(infilepath);
			FileOutputStream fos = new FileOutputStream(outfilepath);
			int hy;

			while ((hy = fis.read()) != -1) {
				
				// \Εϊ
				if (hy == 0x5C){
					int hy2 = fis.read();
					
					// \\̏ꍇ\
					if (hy2 == 0x5C ){
						fos.write(hy);
					}else{
						char[] readchar1 = new char[2];
						readchar1[0] = (char)hy2;
						readchar1[1] = (char)fis.read();
						char[] readchar2 = new char[1];
						readchar2[0] = (char)fis.read();
					
						String outstring1 = new String(readchar1);
						int convint1 = Integer.valueOf(outstring1);
						String outstring2 = new String(readchar2);
						int convint2 = Integer.valueOf(outstring2);
			
						int writeint = outInt(convint1,convint2);
						fos.write(writeint);
					}
				}else{
					fos.write(hy);
				}
				
			}
			fis.close();
			fos.close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	static int outInt(int inta , int intb){
		int _outint = 0;
		String stringA = null;
		String stringB = null;
		if(inta == 20 || inta == 21){
			stringA = "8";
		}else if(inta == 22 || inta == 23){
			stringA = "9";
		}else if(inta == 24 || inta == 25){
			stringA = "A";
		}else if(inta == 26 || inta == 27){
			stringA = "B";
		}else if(inta == 30 || inta == 31){
			stringA = "C";
		}else if(inta == 32 || inta == 33){
			stringA = "D";
		}else if(inta == 34 || inta == 35){
			stringA = "E";
		}else if(inta == 36 || inta == 37){
			stringA = "F";
		}
		
		if((inta % 2) == 1){
			if(intb == 0){
				stringB = "8";
			}else if(intb == 1){
				stringB = "9";
			}else if(intb == 2){
				stringB = "A";
			}else if(intb == 3){
				stringB = "B";
			}else if(intb == 4){
				stringB = "C";
			}else if(intb == 5){
				stringB = "D";
			}else if(intb == 6){
				stringB = "E";
			}else if(intb == 7){
				stringB = "F";
			}
		}else{
			stringB = String.valueOf(intb);
		}
		String outstring = "0x" + stringA + stringB;
		_outint = Integer.decode(outstring).intValue();

		return _outint;
	}

}
